//
//  ActionDragField.m
//  Aurora
//
//  Created by Jonas on 14.12.06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import "ActionDragField.h"


@implementation ActionDragField

- (void)awakeFromNib 
{
	[self registerForDraggedTypes:[NSArray arrayWithObjects:NSFilenamesPboardType, @"WebURLsWithTitlesPboardType", nil]];
}

- (NSDragOperation)draggingEntered:(id <NSDraggingInfo>)sender
{
//	NSLog(@"enter");
	return NSDragOperationLink;
}

- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender
{
//	NSLog(@"perform");
	NSPasteboard *pb = [sender draggingPasteboard];
	
	NSString *fullPath;
	
	if ([[pb types] containsObject:NSFilenamesPboardType]) {
		id propList = [pb propertyListForType:NSFilenamesPboardType];
		fullPath = [propList count] > 0 ? [propList objectAtIndex:0] : nil;
	}
	
	else if ([[pb types] containsObject:@"WebURLsWithTitlesPboardType"]) {
		id propList = [pb propertyListForType:@"WebURLsWithTitlesPboardType"];
		
		id urls = [propList count] > 0 ? [propList objectAtIndex:0] : nil;
		fullPath = [urls count] > 0 ? [urls objectAtIndex:0] : nil;
	}
	
	if (fullPath)
		[[self delegate] setValue:fullPath forKey:@"path"];
	
	return TRUE;
}

@end
