//
//  ActionDragImage.m
//  Aurora
//
//  Created by Jonas on 14.12.06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import "ActionDragImage.h"


@implementation ActionDragImage

- (void)awakeFromNib 
{
	[self registerForDraggedTypes:[NSArray arrayWithObjects:NSFilenamesPboardType, @"WebURLsWithTitlesPboardType", nil]];
}

- (NSDragOperation)draggingEntered:(id <NSDraggingInfo>)sender
{
	return [field draggingEntered:sender];
}

- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender
{
	return [field performDragOperation:sender];
}

- (void)mouseDown:(NSEvent *)theEvent
{
    mouseLoc = [NSEvent mouseLocation];

	NSImage *i = [[field delegate] valueForKey:@"icon"];
	
	NSPasteboard *pboard = [NSPasteboard pasteboardWithName:NSDragPboard];
    [pboard declareTypes:[NSArray arrayWithObjects:NSFilenamesPboardType, @"WebURLsWithTitlesPboardType", nil] owner:nil];

	[self dragImage:i at:NSMakePoint(10, 0) offset:NSZeroSize event:theEvent pasteboard:pboard source:self slideBack:NO];
}

- (unsigned int)draggingSourceOperationMaskForLocal:(BOOL)isLocal
{
	return NSDragOperationNone;
}

- (BOOL)ignoreModifierKeysWhileDragging
{
	return YES;
}

- (void)draggedImage:(NSImage *)anImage endedAt:(NSPoint)aPoint operation:(NSDragOperation)operation
{	
	// Poof!
	NSPoint loc = [NSEvent mouseLocation];
    
//    NSLog(@"from %@ to %@", NSStringFromPoint(mouseLoc), NSStringFromPoint(loc));
    
    float dist = sqrt(pow(ABS(loc.x - mouseLoc.x),2) + pow(ABS(loc.y - mouseLoc.y),2));
    if (dist < 30)
        return;
    
//	NSRect frame = [[self window] frame];
    
    NSShowAnimationEffect(NSAnimationEffectPoof, loc, NSMakeSize(48, 48), nil, nil, nil);
		
    [[field delegate] setValue:nil forKey:@"path"];
//		[[alarmController selection] setValue:nil forKey:@"actionDescription"];		
	
}

@end
